function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function getEntries(data) {
  return (data.items || []).concat(data.includes && data.includes.Entry || []);
}
function isContentfulEntryResourceLink(field) {
  return field && field.sys && field.sys.type === 'ResourceLink' && field.sys.linkType === 'Contentful:Entry';
}
function getResourceLinkFields(data, locale) {
  let fields = getEntries(data).flatMap(_ref => {
    let {
      fields
    } = _ref;
    return Object.values(fields);
  });
  if (locale === '*') {
    fields = fields.flatMap(fieldValue => Object.values(fieldValue));
  }
  fields = fields.flat();
  return fields.filter(isContentfulEntryResourceLink);
}
function parseResourceLink(resourceLink) {
  const urn = resourceLink.sys.urn;
  const [, spaceId,, entryId] = urn.split('/');
  return {
    spaceId,
    entryId,
    urn
  };
}
function groupBy(key, objArray) {
  return objArray.reduce((acc, obj) => {
    const objKey = obj[key];
    acc[objKey] = (acc[objKey] || []).concat(obj);
    return acc;
  }, {});
}
async function getEntitiesFromSpace(spaceId, entries, additionalApis, include, locale) {
  const apiInstance = additionalApis[spaceId];
  if (!apiInstance) {
    return [];
  }
  const entryIds = entries.map(_ref2 => {
    let {
      entryId
    } = _ref2;
    return entryId;
  });
  const uniqueEntryIds = [...new Set(entryIds)];
  const data = await apiInstance.getEntries({
    'sys.id[in]': uniqueEntryIds.join(','),
    include,
    locale
  }, {
    wrapEntryCollection: false
  }).catch(() => ({}));
  return _objectSpread(_objectSpread({}, data.includes), {}, {
    Entry: getEntries(data)
  });
}
export async function addResourceLinksToIncludes(data) {
  let additionalApis = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  let {
    include = 1,
    locale
  } = arguments.length > 2 ? arguments[2] : undefined;
  if (include === 0) {
    return data;
  }
  const resourceLinkFields = getResourceLinkFields(data, locale);
  const entitiesBySpace = groupBy('spaceId', resourceLinkFields.map(parseResourceLink));
  const resourceLinkPromises = Object.entries(entitiesBySpace).map(_ref3 => {
    let [spaceId, entries] = _ref3;
    return getEntitiesFromSpace(spaceId, entries, additionalApis, include - 1, locale);
  });
  const resolvedEntitiesByType = await Promise.all(resourceLinkPromises);
  const includesObjects = [data.includes || {}, ...resolvedEntitiesByType];
  return _objectSpread(_objectSpread({}, data), {}, {
    includes: includesObjects.reduce((result, entitiesByType) => {
      Object.entries(entitiesByType).forEach(_ref4 => {
        let [entityType, entities] = _ref4;
        result[entityType] = (result[entityType] || []).concat(entities);
      });
      return result;
    }, {})
  });
}